package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class LancamentoSaidaPage extends PageBase {

    By filtroStatus = By.xpath("//div[@class='col-xs-12 zh-field last-of-row'][1]//li[text() = 'texto']");
    By filtroStatusAux = By.xpath("//*[@id='IDSTATUS']/following-sibling::div[1]");
    By filtroUnidadeAux = By.id("NMFILIAL");
    By filtroUnidade = By.xpath("//*[@id='NMFILIAL']//input");
    By filtroDestRemet = By.xpath("//*[@id='IDORIGDESTNF']/following-sibling::div[1]//li[text() = 'texto']");
    By getFiltroDestRemetAux = By.xpath("//*[@id='IDORIGDESTNF']/following-sibling::div[1]");
    By filtroSerie = By.xpath("//*[@id='DSSERIE']//input");
    By filtroSerieAux = By.id("DSSERIE");
    By filtroAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro'][1]");
    By adicionarLancamento = By.xpath("//a[@data-zh-title-tooltip = 'Adicionar (F2)']");
    By destinatarioField = By.xpath("//div[@data-zh-id='124894852332827515384203']//input");
    By destinatarioSelect = By.xpath("//div[@data-zh-id='124894852332827515384203']//span[@data-item-identifier='10767821000101']");
    By serieField = By.xpath("//div[@id='DSSERIE']//input[@type ='text']");
    By serieSearchBtn = By.xpath("//*[@data-zh-id='124894852315306746704216']//*[@data-item-identifier='1']");
    By dataSaidaField = By.id("DTENTRSAID");
    By salvarLancamentoBtn = By.xpath("//div[@id='footer']//span[text() = 'Salvar']");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By adicionarProdutoBtn = By.xpath("//*[@data-zh-id='124894852338340472934106']//div");
    By produtoField = By.xpath("//*[@data-zh-id='12489485237439031144081']//div[@id='NMPRODUTO']");
    By produtosMenu = By.xpath("//label//a[text() = 'Produtos']");
    By produtoSearchField = By.xpath("//*[@data-zh-id='12489485237439031144081']//input");
    By produtoSearch = By.xpath("//div[@data-zh-id='12489485237439031144081']//span[@data-item-identifier='00A103800001']");
    By ProdutoSearchDois = By.xpath("//div[@data-zh-id='12489485237439031144081']//span[@data-item-identifier='00A103900000']");
    By ProdutoSearchTres = By.xpath("//div[@data-zh-id='12489485237439031144081']//span[@data-item-identifier='00A104000000']");
    By loteProdutoField = By.id("NRLOTEESTQ");
    By loteProdutoSelect = By.xpath("//div[@ng-if='showDropdown']//span[@data-item-identifier='I']");
    By confirmarBtn = By.xpath("//div[@id='footer']//span[text() = 'Confirmar']");
    By quantidadeProdutoField = By.xpath("//input[@id='QTITEMPROD']");
    By valorProdutoField = By.xpath("//input[@id='VRUNITITEM']");
    By salvarProdutoBtn = By.xpath("//div[@id='footer']//span[text() = 'Salvar']");
    By voltarBtn = By.xpath("//*[@data-zh-id='124894852310140657254104']//span[2]");
    By fecharLancamentoBtn = By.xpath("//div[@id='footer']//span[text() = 'Fechar']");
    By fecharLancamentoConfirmarBtn = By.xpath("//button//span[text() = 'Sim']");
    By statusLancamento = By.xpath("//span[text() ='Pendente']");

    public void preencherFiltroStatus(String status){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(filtroStatusAux);
        clickWithText(filtroStatus,status);
    }
    public void preencherFiltroUnidade(String unidade){
        click(filtroUnidadeAux);
        waitForInvisibilityOfElementLocated(loadingWait);
        sendKeys(filtroUnidade, unidade);
    }
    public void preencherFiltroRemetente(String remetente){
        click(getFiltroDestRemetAux);
        clickWithText(filtroDestRemet,remetente);
    }
    public void preencherFiltroSerie(String serie){
        click(filtroSerieAux);
        sendKeys(filtroSerie,serie);
    }
    public void clicarAplicarFiltro(){
        click(filtroAplicarFiltro);
    }
    public void clicarAdicionarLancamento(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(adicionarLancamento);
        waitForInvisibilityOfElementLocated(loadingWait);}

    public void clicarPesquisaDestinatario(){
        click(destinatarioField);
    }
    public void clicarEscolherDestinatario(){
       click(destinatarioSelect);
    }
    public void clicarPesquisaSerie(){
        click(serieField);
        click(serieSearchBtn);
    }
    public void preencherDataSaida(String data){
        sendKeys(dataSaidaField,data);
    }
    public void salvarLancamento(){
        click(salvarLancamentoBtn);
    }
    public void produtosMenu(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(produtosMenu);
    }
    public void clicarAdicionarProduto(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(adicionarProdutoBtn);
    }
    public void clicarFieldProduto(){
        click(produtoField);
    }
    public void preencherNomeProduto(String nomeProduto){
        sendKeys(produtoSearchField, nomeProduto);
    }
    public void preencherNomeProdutoDois(String nomeProdutoDois){
        sendKeys(produtoSearchField, nomeProdutoDois);
    }
    public void preencherNomeProdutoTres(String nomeProdutoTres){
        sendKeys(produtoSearchField, nomeProdutoTres);
    }
    public void clicarEscolherProduto(){
        click(produtoSearch);
    }

    public void clicarEscolherProdutoDois(){
        click(ProdutoSearchDois);
    }
    public void clicarEscolherProdutoTres(){
        click(ProdutoSearchTres);
    }
    public void clicarPesquisaLoteProduto(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(loteProdutoField);
    }
    public void clicarEscolherLoteProduto(){
        click(loteProdutoSelect);
    }
    public void clicarConfirmarProduto(){
        click(confirmarBtn);
    }
    public void preencherQuantidadeProduto(String quantidadeProduto){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(quantidadeProdutoField);
        sendKeys(quantidadeProdutoField,quantidadeProduto);
    }
    public void preencherValorProduto(String valor){
        click(valorProdutoField);
        sendKeys(valorProdutoField, valor);
    }
    public void clicarSalvarProduto(){
        click(salvarProdutoBtn);
    }
    public void clicarVoltarBtn(){click(voltarBtn);
    }
    public void clicarFecharLancamento(){
        click(fecharLancamentoBtn);
    }
    public void clicarConfirmarFecharLancamento(){
        click(fecharLancamentoConfirmarBtn);
    }
    public String retornarStatusLancamento(){
        return getText(statusLancamento);
    }
    //clickWithoutClickable(operacaoField);
    //System.out.println(driver.getPageSource());
    //driver.findElement(operacaoFieldAux).click();
    //SendKeysJavaScript(operacaoField,operacao);
    //sendKeys(operacaoField,operacao);
    //click(operacaoFieldAux);
    //ClickJavaScript(operacaoFieldAux);
    //driver.findElement(operacaoFieldAux).click();
    //expandShadowRootElement(operacaoFieldAux).findElement(By.xpath(""))
    //System.out.println(getText(operacaoFieldAux));
}
